<template>
	<section class="FieldsViewControlsMobile grey lighten-4" aria-label="filters">
		<div class="FieldsViewControlsMobile-wrapper">
			<fields-view-search-input></fields-view-search-input>
			<v-dialog v-model="showDialog" fullscreen hide-overlay>
				<template v-slot:activator="{ on, attrs }">
					<v-btn class="FieldsViewControlsMobile-dialogButton" v-bind="attrs" v-on="on" outlined icon tile>
						<v-icon>mdi-tune</v-icon>
					</v-btn>
				</template>

				<v-card>
					<v-toolbar color="#f5f5f5" class="FieldsViewControlsMobile-dialogToolbar">
						<v-toolbar-title>Filter Field Results</v-toolbar-title>
						<v-spacer></v-spacer>
						<v-btn icon @click="showDialog = false">
							<v-icon>mdi-close</v-icon>
						</v-btn>
					</v-toolbar>
					<div class="FieldsViewControlsMobile-filters">
						<fields-view-group-filter class="FieldsViewControlsMobile-control"></fields-view-group-filter>

						<fields-view-recent-activity-filter
							class="FieldsViewControlsMobile-control"
						></fields-view-recent-activity-filter>

						<fields-view-status-filter class="FieldsViewControlsMobile-control"></fields-view-status-filter>

						<fields-view-sort-by class="FieldsViewControlsMobile-control"></fields-view-sort-by>

						<button class="FieldsViewControlsMobile-clearAll primary--text" @click="clearAllFilters">
							Clear all filters
						</button>

						<v-btn class="FieldsViewControlsMobile-viewResults" dark large color="primary" @click="showDialog = false">
							View Results ({{ fieldRowsLength }})
						</v-btn>
					</div>
				</v-card>
			</v-dialog>
		</div>

		<v-divider></v-divider>
	</section>
</template>

<script lang="ts">
import { defineComponent, ref, computed } from '@vue/composition-api';
import FieldsViewSearchInput from './FieldsViewSearchInput.vue';
import FieldsViewGroupFilter from './FieldsViewGroupFilter.vue';
import FieldsViewRecentActivityFilter from './FieldsViewRecentActivityFilter.vue';
import FieldsViewStatusFilter from './FieldsViewStatusFilter.vue';
import FieldsViewSortBy from './FieldsViewSortBy.vue';

export default defineComponent({
	components: {
		FieldsViewSearchInput,
		FieldsViewGroupFilter,
		FieldsViewRecentActivityFilter,
		FieldsViewStatusFilter,
		FieldsViewSortBy,
	},
	setup(_, { root }) {
		const showDialog = ref(false);

		const fieldRowsLength = computed(() => root.$store.getters['fieldsView/getFieldRowsLength']);

		return {
			showDialog,
			fieldRowsLength,
			clearAllFilters: () => {
				root.$store.dispatch('fieldsView/clearAllFilters');
			},
		};
	},
});
</script>

<style lang="scss">
.FieldsViewControlsMobile {
	z-index: 1;
	position: sticky;
	top: 0;
	display: flex;
	flex-direction: column;

	.FieldsViewControlsMobile-wrapper {
		display: flex;
	}

	.FieldsViewSearchInput {
		flex-grow: 1;
		margin: 0 16px;
	}

	.FieldsViewControlsMobile-dialogButton {
		margin-right: 16px;
		background: #fff;

		&.v-btn--tile {
			border-radius: 4px;
		}

		&.v-btn--icon.v-size--default {
			width: 40px;
			height: 40px;
		}
	}
}

.FieldsViewControlsMobile-dialogToolbar {
	position: fixed;
	top: 0;
	width: 100%;
	z-index: 1;
}

.FieldsViewControlsMobile-filters {
	display: flex;
	flex-direction: column;
	overflow-y: scroll;
	width: 100%;
	height: 100%;
	background: #fff;
	margin-top: 56px; /* toolbar height */
	margin-bottom: 44px; /* view results button height */

	.FieldsViewControlsMobile-control {
		min-width: 150px;

		&:first-child {
			margin-top: 8px;
		}
		&:not(:first-child) {
			margin-top: 16px;
		}
	}

	.FieldsViewControlsMobile-clearAll {
		margin: 16px 0;
	}

	.FieldsViewControlsMobile-viewResults {
		position: fixed;
		bottom: 0;
		width: 100%;
	}
}
</style>
